﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win.UltraWinGrid;

namespace UltraGirdFilterConditions
{
    public partial class Form1 : Form
    {

        public MyDynamicSQL MySQL;
        public Form1()
        {
            InitializeComponent();
            ultraGrid1.DisplayLayout.Scrollbars = Scrollbars.Vertical;
            ultraGrid1.Height = ultraGrid1.DisplayLayout.Bands[0].Columns[0].Header.Height + ultraGrid1.DisplayLayout.Bands[0].Header.Height;
        }

        private void ultraGrid1_AfterRowFilterChanged(object sender, AfterRowFilterChangedEventArgs e)
        {
            
            MySQL = new MyDynamicSQL(ultraGrid1.DisplayLayout.Bands[0].ColumnFilters);
            ultraFormattedTextEditor1.Text += MySQL.GetSQL() + Environment.NewLine;
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
           // e.Row.Hidden = true;
        }
    }

    public class MyDynamicSQL
    {
        private ColumnFiltersCollection ColFilterCollection;
        private string Columns;
        private string Condition;


        public MyDynamicSQL(ColumnFiltersCollection cfc)
        {
            this.ColFilterCollection = cfc;
            this.Columns = "";
            this.Condition = "";
        }

        public string GetSQL()
        {
            foreach (ColumnFilter col in ColFilterCollection)
            {
                if (Columns.Length == 0) Columns = col.Column.Key;
                else Columns = Columns + ", " + col.Column.Key;

               foreach (FilterCondition condition in col.FilterConditions)
                {
                    string temp = "";
                    switch (condition.ComparisionOperator)
                    { 
                        case FilterComparisionOperator.Contains:
                            temp = condition.ToString();
                            temp = temp.Replace("Contains", " IN ( ");
                            temp = temp.Replace(condition.CompareValue.ToString(), condition.CompareValue + ") ");
                            break;
                        case FilterComparisionOperator.DoesNotContain:
                            temp = condition.ToString();
                            temp = temp.Replace("Contains", " NOT IN ( ");
                            temp = temp.Replace(condition.CompareValue.ToString(), condition.CompareValue + ") ");
                            break;
                        case FilterComparisionOperator.Like:
                            temp = condition.ToString();
                            temp = temp.Replace(condition.CompareValue.ToString(), " %" + condition.CompareValue + "% ");
                            break;
                        case FilterComparisionOperator.NotLike:
                            temp = condition.ToString();
                            temp = temp.Replace("NotLike", " NOT Like ");
                            temp = temp.Replace(condition.CompareValue.ToString(), " %" + condition.CompareValue + "% ");
                            break;
                        case FilterComparisionOperator.StartsWith:
                            temp = condition.ToString();
                            temp = temp.Replace("StartsWith", " Like ");
                            temp = temp.Replace(condition.CompareValue.ToString(), " %" + condition.CompareValue);
                            break;
                        case FilterComparisionOperator.EndsWith:
                            temp = condition.ToString();
                            temp = temp.Replace("StartsWith", " Like ");
                            temp = temp.Replace(condition.CompareValue.ToString(),  condition.CompareValue +"% ");
                            break;
                            
                            // TO DO
                            // WE NEED TO CONVERT  ALL OPPERATORS IN SQL 

                        default:
                            
                            temp = condition.ToString();
                            break;
                    }

                    if (Condition.Length == 0) Condition = temp ;//condition.ToString();
                    else Condition = Condition + " " + col.LogicalOperator + " " + temp;// condition.ToString();
                }
            }
            if (Condition.Length > 0) Condition = "WHERE " + Condition;
            return "SELECT " + Columns + " FROM Tables WITH(NOLOCK) " + Condition;
        }
    }
}
